"""Track basic IRC settings and similar."""

import logging

from django.db import models


log = logging.getLogger('ircbot.models')


class BotAdmin(models.Model):

    """Configure admins, which can do things through the bot that others can't."""

    nickmask = models.CharField(max_length=200, unique=True)

    def __unicode__(self):
        """String representation."""

        return u"{0:s}".format(self.nickmask)


class IrcChannel(models.Model):

    """Track channel settings."""

    name = models.CharField(max_length=200, unique=True)
    autojoin = models.BooleanField(default=False)

    def __unicode__(self):
        """String representation."""

        return u"{0:s}".format(self.name)


class IrcPlugin(models.Model):

    """Represent an IRC plugin and its loading settings."""

    path = models.CharField(max_length=200, unique=True)
    autoload = models.BooleanField(default=False)

    def __unicode__(self):
        """String representation."""

        return u"{0:s}".format(self.path)
